<?php

/**********************************************************************
File Name:              SDM220.php
Dev:                    Daniele De Santis
Email:                  desantis@areasx.com
Web:                    http://www.areasx.com

Versione:               0.0
Data:                   12/09/14
Note Hardware:  
Note Software: 
**********************************************************************/
$json_on      = 1;
$txt_on       = 0;
$log_on       = 1;
$server_ip    = "192.168.9.112";
$server_port  = 1470;
$address      = 0x01;


class ModBusRTUoverTCP {
  public $debug     = 0;
  public $rxdata    = "";
  public function InitLan($ip, $port, $tout=5){
    $this->sid = @fsockopen($ip, $port, $errno, $errstr, $tout);
    if (!$this->sid) {
      if($this->debug)  echo "Connessione TCP IP con l'host ".$ip.":".$port." fallita<br>";
      return 0;
    }
    if($this->debug)  echo "Connessione TCP IP con l'host ".$ip.":".$port." riuscita<br>";
    return 1;
  }
  public function CRC($cmd){
    $poly = 0xA001;
    $crc  = 0xFFFF;
    for ($x=0; $x<strlen($cmd); $x++ ) {
      $crc =  $crc ^ ord($cmd[$x]) ;
      for ($i=0; $i<8; $i++){
        $carrybit = $crc & 1;
        $crc = $crc>>1;
        if ($carrybit == 1) $crc = ($crc ^ $poly);
      }
    }
    return $crc;
  }
  public function PrintHEX($cmd){
    for ( $x=0; $x<strlen($cmd); $x++ )
      printf("0x%x ", ord($cmd[$x]));
    print "<br>";
  }
  public function SendCmd($address, $function, $register, $registervalue, $registerqt=1, $bytecount=2){
    $txcmd = chr($address) . chr($function) . chr(($register>>8) & 0xFF) . chr(($register & 0xFF)) . chr(0x00) . chr(0x01);  //. chr(0x21) . chr(0xCB);
    if($registerqt>1) {
      $txcmd .= chr(($registerqt>>8) & 0xFF) . chr(($registerqt & 0xFF));
      if($bytecount) $txcmd .= chr($bytecount);
    }
    for($i=($bytecount-1); $i<=-1; $i--)
      $txcmd .= chr(($registervalue>>($i * 0x08) & 0xFF));
    $cmd_crc=$this->CRC($txcmd);
    $txcmd= $txcmd . chr(($cmd_crc & 0xFF)) . chr((($cmd_crc>>8) & 0xFF)); #Appendo il CRC
    if($this->debug) $this->PrintHEX($txcmd);
    fputs($this->sid, $txcmd, strlen($txcmd));
    $this->rxdata="";
    $rxcmd=fread ($this->sid,strlen($txcmd));
    if(strlen($rxcmd)>3){
      if($this->debug) $this->PrintHEX($rxcmd);
      $rxcrc = $rxcmd[strlen($rxcmd)-2].$rxcmd[strlen($rxcmd)-1];
      $mycrc=$this->CRC(substr($rxcmd, 0, -2));
      $mycrc=chr(($mycrc & 0xFF)) . chr((($mycrc>>8) & 0xFF));
      if($rxcrc==$mycrc){
        $this->rxdata=$rxcmd;
        return 0;
      } else {
        if($this->debug)  echo "Errore CRC<br>";
        return 1;
      }
    }
    return 2;
  }
  public function CloseLan(){
    fclose($this->sid);
    if($this->debug)  echo "Connessione TCP IP chiusa<br>";
  }
}


function IEEE7542Float($byte){
  $val  = (ord($byte[0])<<24) + (ord($byte[1])<<16) + (ord($byte[2])<<8) + ord($byte[3]);
  $x =  ($val & ((1 << 23) - 1)) + (1 << 23) * ($val >> 31 | 1);
  $e = ($val >> 23 & 0xFF) - 127;
  $s=1;
  if((ord($byte[0])>>7) & 0x01) $s = -1;
  return  ($x * (pow(2,($e - 23))) * $s);
}

//Test SDM220
$SDM220 = new ModBusRTUoverTCP();
$SDM220->debug =0;

if($SDM220->InitLan($server_ip, $server_port)){
  //Tensione
  $Tensione=0;
  if($SDM220->SendCmd($address, 0x4, 0x0000, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $Tensione = IEEE7542Float($rxbyte);  
  }
  //Corrente
  $Corrente=0;
  if($SDM220->SendCmd($address, 0x4, 0x0006, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $Corrente = IEEE7542Float($rxbyte);  
  }
  //Potenza
  $Potenza=0;
  if($SDM220->SendCmd($address, 0x4, 0x000C, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $Potenza = IEEE7542Float($rxbyte);  
  }
  //Frequenza
  $Frequenza=0;
  if($SDM220->SendCmd($address, 0x4, 0x0046, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $Frequenza = IEEE7542Float($rxbyte);  
  }
  //VA
  $VA=0;
  if($SDM220->SendCmd($address, 0x4, 0x0012, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $VA = IEEE7542Float($rxbyte);  
  }
  //Fattore Potenza
  $FattorePotenza=0;
  if($SDM220->SendCmd($address, 0x4, 0x001E, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $FattorePotenza = IEEE7542Float($rxbyte);  
  }
  
  $Contatore=0;
  if($SDM220->SendCmd($address, 0x4, 0x0201, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $Contatore = IEEE7542Float($rxbyte);  
  }
  $ContatoreIn=0;
  if($SDM220->SendCmd($address, 0x4, 0xF101, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $ContatoreIn = IEEE7542Float($rxbyte);  
  }
  $ContatoreOut=0;
  if($SDM220->SendCmd($address, 0x4, 0xF201, 0x0002)==0){
    $rxbyte = $SDM220->rxdata[3] . $SDM220->rxdata[4] . $SDM220->rxdata[5] . $SDM220->rxdata[6];
    $ContatoreOut = IEEE7542Float($rxbyte);  
  }  
  $SDM220->CloseLan();  
  
/*
if(1){
  //Debug
  $Tensione ="230.3";
  $Corrente = "1.1";
  $Potenza  = "253.33"; 
  $Frequenza = "49.9";
  $VA        = "253.33";
  $FattorePotenza = "1.0";
  $Contatore    = "120";
  $ContatoreIn  = "100";
  $ContatoreOut = "0";
*/
  
  if($json_on){
    $json=sprintf("{\"SDM220\":[{\"tensione\":\"%.1f\", \"corrente\":\"%.1f\", \"potenza\":\"%.1f\", \"frequenza\":\"%.1f\",\"va\":\"%.1f\", \"fattorepotenza\":\"%.1f\", \"contatore\":\"%.1f\", \"contatorein\":\"%.1f\", \"contatoreout\":\"%.1f\"} ]}", $Tensione, $Corrente, $Potenza, $Frequenza, $VA, $FattorePotenza, $Contatore, $ContatoreIn, $ContatoreOut);
    print $json;
  } else {
    if($txt_on){
      print "SDM220C ******************<br>";
      printf("Tensione: %.1f V<br>", $Tensione);
      printf("Corrente: %.1f A<br>", $Corrente);
      printf("Potenza: %.1f W<br>",  $Potenza);
      printf("Frequenza: %.1f Hz<br>", $Frequenza);
      printf("VA: %.1f VA<br>",  $VA);
      printf("Fattore Potenza: %.1f<br>", $FattorePotenza);
      printf("Contatore Tot: %.1f kWh<br>", $Contatore);
      printf("Contatore In: %.1f kWh<br>", $ContatoreIn);
      printf("Contatore Out: %.1f kWh<br>", $ContatoreOut);
    }
  }

  if($log_on){
    $log_message = sprintf("%s;%s;%.1f;%.1f;%.1f;%.1f;%.1f;%.1f;%.1f;%.1f;%.1f;", date("j/n/Y"),date("H:i:s"),$Tensione, $Corrente, $Potenza, $Frequenza, $VA, $FattorePotenza, $Contatore, $ContatoreIn, $ContatoreOut);
    $fid = @fopen("./log.txt", 'a');
    if($fid){
      fwrite($fid, $log_message. "\r\n" );
      fclose($fid);
    }
  }
}

?>
